---
schemaVersion: 2.2.0
metadata: {}
components:
  - name: tooling-container
    attributes:
      gl/inject-editor: true
    container:
      image: quay.io/mloriedo/universal-developer-image:ubi8-dw-demo
      args:
        - |-
          sshd_path=$(which sshd)
          if [ -x "$sshd_path" ]; then
            echo "Starting sshd on port ${GL_SSH_PORT}"
            $sshd_path -D -p $GL_SSH_PORT &
          else
            echo "'sshd' not found in path. Not starting SSH server."
          fi
          /projects/.gl-editor/start_server.sh
      command:
        - "/bin/sh"
        - "-c"
      volumeMounts:
        - name: gl-workspace-data
          path: /projects
      env:
        - name: GL_EDITOR_VOLUME_DIR
          value: "/projects/.gl-editor"
        - name: GL_EDITOR_LOG_LEVEL
          value: "info"
        - name: GL_EDITOR_PORT
          value: "60001"
        - name: GL_SSH_PORT
          value: "60022"
        - name: GL_EDITOR_ENABLE_MARKETPLACE
          value: "true"
      endpoints:
        - name: editor-server
          targetPort: 60001
          exposure: public
          secure: true
          protocol: https
        - name: ssh-server
          targetPort: 60022
          exposure: internal
          secure: true
      dedicatedPod: false
      mountSources: true
  - name: gl-workspace-data
    volume:
      size: 15Gi
  - name: gl-editor-injector
    container:
      image: registry.gitlab.com/gitlab-org/gitlab-web-ide-vscode-fork/web-ide-injector:6
      volumeMounts:
        - name: gl-workspace-data
          path: /projects
      env:
        - name: GL_EDITOR_VOLUME_DIR
          value: "/projects/.gl-editor"
      memoryLimit: 256Mi
      memoryRequest: 128Mi
      cpuLimit: 500m
      cpuRequest: 100m
  - name: gl-cloner-injector
    container:
      image: alpine/git:2.36.3
      volumeMounts:
        - name: gl-workspace-data
          path: "/projects"
      args:
        - |-
          if [ ! -d '/projects/test-project' ];
          then
            git clone --branch master http://localhost/test-group/test-project.git /projects/test-project;
          fi
      command:
        - "/bin/sh"
        - "-c"
      memoryLimit: 256Mi
      memoryRequest: 128Mi
      cpuLimit: 500m
      cpuRequest: 100m
events:
  preStart:
    - gl-editor-injector-command
    - gl-cloner-injector-command
commands:
  - id: gl-editor-injector-command
    apply:
      component: gl-editor-injector
  - id: gl-cloner-injector-command
    apply:
      component: gl-cloner-injector
